Index: Czech.keymap
===================================================================
--- Czech.keymap	(revision 28886)
+++ Czech.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Serbian(Latin).keymap
===================================================================
--- Serbian(Latin).keymap	(revision 28886)
+++ Serbian(Latin).keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: US-International.keymap
===================================================================
--- US-International.keymap	(revision 28886)
+++ US-International.keymap	(working copy)
@@ -37,11 +37,11 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
-ROption = 0x60
+ROption = 0x5f
 Menu = 0x68
 #
 # Lock settings
Index: Polish.keymap
===================================================================
--- Polish.keymap	(revision 28886)
+++ Polish.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Macedonian.keymap
===================================================================
--- Macedonian.keymap	(revision 28886)
+++ Macedonian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Serbian(Cyrillic).keymap
===================================================================
--- Serbian(Cyrillic).keymap	(revision 28886)
+++ Serbian(Cyrillic).keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Canadian-French.keymap
===================================================================
--- Canadian-French.keymap	(revision 28886)
+++ Canadian-French.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Portuguese.keymap
===================================================================
--- Portuguese.keymap	(revision 28886)
+++ Portuguese.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Polish(programmer's).keymap
===================================================================
--- Polish(programmer's).keymap	(revision 28886)
+++ Polish(programmer's).keymap	(working copy)
@@ -39,9 +39,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Spanish.keymap
===================================================================
--- Spanish.keymap	(revision 28886)
+++ Spanish.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Swedish.keymap
===================================================================
--- Swedish.keymap	(revision 28886)
+++ Swedish.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: ISO-9995.keymap
===================================================================
--- ISO-9995.keymap	(revision 28886)
+++ ISO-9995.keymap	(working copy)
@@ -37,7 +37,7 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
 RControl = 0x60
 LOption = 0x66
Index: Dutch.keymap
===================================================================
--- Dutch.keymap	(revision 28886)
+++ Dutch.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Icelandic.keymap
===================================================================
--- Icelandic.keymap	(revision 28886)
+++ Icelandic.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Swiss-French.keymap
===================================================================
--- Swiss-French.keymap	(revision 28886)
+++ Swiss-French.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Irish.keymap
===================================================================
--- Irish.keymap	(revision 28886)
+++ Irish.keymap	(working copy)
@@ -37,11 +37,11 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
-ROption = 0x60
+ROption = 0x5f
 Menu = 0x68
 #
 # Lock settings
Index: Swiss-German.keymap
===================================================================
--- Swiss-German.keymap	(revision 28886)
+++ Swiss-German.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Bulgarian(Cyrillic).keymap
===================================================================
--- Bulgarian(Cyrillic).keymap	(revision 28886)
+++ Bulgarian(Cyrillic).keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Ukrainian.keymap
===================================================================
--- Ukrainian.keymap	(revision 28886)
+++ Ukrainian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Brazilian(ABNT2).keymap
===================================================================
--- Brazilian(ABNT2).keymap	(revision 28886)
+++ Brazilian(ABNT2).keymap	(working copy)
@@ -39,9 +39,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Dvorak.keymap
===================================================================
--- Dvorak.keymap	(revision 28886)
+++ Dvorak.keymap	(working copy)
@@ -40,11 +40,11 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
-ROption = 0x60
+ROption = 0x5f
 Menu = 0x68
 #
 # Lock settings
Index: Faeroese.keymap
===================================================================
--- Faeroese.keymap	(revision 28886)
+++ Faeroese.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Lithuanian(Baltic).keymap
===================================================================
--- Lithuanian(Baltic).keymap	(revision 28886)
+++ Lithuanian(Baltic).keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Greek.keymap
===================================================================
--- Greek.keymap	(revision 28886)
+++ Greek.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Slovak.keymap
===================================================================
--- Slovak.keymap	(revision 28886)
+++ Slovak.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Turkish(type-F).keymap
===================================================================
--- Turkish(type-F).keymap	(revision 28886)
+++ Turkish(type-F).keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Belgian.keymap
===================================================================
--- Belgian.keymap	(revision 28886)
+++ Belgian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Romanian.keymap
===================================================================
--- Romanian.keymap	(revision 28886)
+++ Romanian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Albanian.keymap
===================================================================
--- Albanian.keymap	(revision 28886)
+++ Albanian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: French.keymap
===================================================================
--- French.keymap	(revision 28886)
+++ French.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Danish.keymap
===================================================================
--- Danish.keymap	(revision 28886)
+++ Danish.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: German.keymap
===================================================================
--- German.keymap	(revision 28886)
+++ German.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Turkish(type-Q).keymap
===================================================================
--- Turkish(type-Q).keymap	(revision 28886)
+++ Turkish(type-Q).keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Slovene.keymap
===================================================================
--- Slovene.keymap	(revision 28886)
+++ Slovene.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Hungarian.keymap
===================================================================
--- Hungarian.keymap	(revision 28886)
+++ Hungarian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Hebrew.keymap
===================================================================
--- Hebrew.keymap	(revision 28886)
+++ Hebrew.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: United-Kingdom.keymap
===================================================================
--- United-Kingdom.keymap	(revision 28886)
+++ United-Kingdom.keymap	(working copy)
@@ -37,11 +37,11 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
-ROption = 0x60
+ROption = 0x5f
 Menu = 0x68
 #
 # Lock settings
Index: American.keymap
===================================================================
--- American.keymap	(revision 28886)
+++ American.keymap	(working copy)
@@ -37,11 +37,11 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
-ROption = 0x60
+ROption = 0x5f
 Menu = 0x68
 #
 # Lock settings
Index: Byelorussian.keymap
===================================================================
--- Byelorussian.keymap	(revision 28886)
+++ Byelorussian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Estonian.keymap
===================================================================
--- Estonian.keymap	(revision 28886)
+++ Estonian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Italian.keymap
===================================================================
--- Italian.keymap	(revision 28886)
+++ Italian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Russian.keymap
===================================================================
--- Russian.keymap	(revision 28886)
+++ Russian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68
Index: Arabic(102).keymap
===================================================================
--- Arabic(102).keymap	(revision 28886)
+++ Arabic(102).keymap	(working copy)
@@ -37,11 +37,11 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
-ROption = 0x60
+ROption = 0x5f
 Menu = 0x68
 #
 # Lock settings
Index: Japanese.keymap
===================================================================
--- Japanese.keymap	(revision 28886)
+++ Japanese.keymap	(working copy)
@@ -37,11 +37,11 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x5f
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
-ROption = 0x60
+ROption = 0x5f
 Menu = 0x68
 #
 # Lock settings
Index: Norwegian.keymap
===================================================================
--- Norwegian.keymap	(revision 28886)
+++ Norwegian.keymap	(working copy)
@@ -37,9 +37,9 @@
 LShift = 0x4b
 RShift = 0x56
 LCommand = 0x5d
-RCommand = 0x60
+RCommand = 0x00
 LControl = 0x5c
-RControl = 0x00
+RControl = 0x60
 LOption = 0x66
 ROption = 0x5f
 Menu = 0x68